// Stuff for dealing with level set

#ifndef LEVELSET_H
#define LEVELSET_H

typedef struct{
   int nx, ny, nz;
   float x0, y0, z0;
   float x1, y1, z1;
   float dx;
   float *phi;
} LevelSet;

void read_level_set(const char *filename, LevelSet *ls);
float phi(const LevelSet *ls, float x, float y, float z);
void normal(const LevelSet *ls, float x, float y, float z, float normal[3]);

#endif
