#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include "particles.h"

void init_particles(ParticleSystem *ps)
{
   ps->n=0; // initially 0 particles
   ps->nmax=1000; // but room for 1000
   ps->x=(float*)malloc(3*ps->nmax*sizeof(float));
   ps->v=(float*)malloc(3*ps->nmax*sizeof(float));
   ps->r=(float*)malloc(ps->nmax*sizeof(float));
   ps->m=(float*)malloc(ps->nmax*sizeof(float));
}

void add_particle(ParticleSystem *ps, float x, float y, float z, float u, float v, float w, float r, float m)
{
   int i=ps->n;
   ++ps->n;
   if(ps->n==ps->nmax){ // if we ran out of space
      ps->nmax*=2; // allow for double the size
      ps->x=(float*)realloc(ps->x, 3*ps->nmax*sizeof(float));
      ps->v=(float*)realloc(ps->v, 3*ps->nmax*sizeof(float));
      ps->r=(float*)realloc(ps->r, ps->nmax*sizeof(float));
      ps->m=(float*)realloc(ps->m, ps->nmax*sizeof(float));
   }
   ps->x[3*i]=x;
   ps->x[3*i+1]=y;
   ps->x[3*i+2]=z;
   ps->v[3*i]=u;
   ps->v[3*i+1]=v;
   ps->v[3*i+2]=w;
   ps->r[i]=r;
   ps->m[i]=m;
}

void write_particles(const ParticleSystem *ps, const char *filename_format, ...)
{
   char *filename;
   FILE *fp;
   va_list ap;

   va_start(ap, filename_format);
   vasprintf(&filename, filename_format, ap);
   fp=fopen(filename, "wt");
   free(filename);
   if(fp){
      int i;
      fprintf(fp, "%d\n", ps->n);
      for(i=0; i<ps->n; ++i)
         fprintf(fp, "%.7g %.7g %.7g 1 1 1 %.7g\n", ps->x[3*i], ps->x[3*i+1], ps->x[3*i+2], ps->r[i]);
   }
   fclose(fp);
}

